// Random number generator.

#include <iostream>
#include <math.h>
#include <cstdlib>
#include <vector>

#define ranf() ((double)random()/(1.0+(double)RAND_MAX))

using namespace std;

// Using the polar form of Box-Muller transformation.
vector<double> gaussian(int n, double m, double s) {
  srandom(time(NULL));
  vector<double> nums;
  for (int i = 0; i < n / 2; ++i) {
    double x1, x2, w, y1, y2;
    do {
      x1 = 2.0 * ranf() - 1.0;
      x2 = 2.0 * ranf() - 1.0;
      w = x1 * x1 + x2 * x2;
    } while (w >= 1.0);
    w = sqrt((-2.0 * log(w)) / w);
    y1 = x1 * w;
    y2 = x2 * w;
    nums.push_back(y1);
    nums.push_back(y2);
  }
  for (int i = 0; i < nums.size(); ++i) {
    nums[i] = nums[i] * s + m;
  }
  return nums;
}

int main() {
  vector<double> nums = gaussian(100000, 3200, 150);
  for (int i = 0; i < nums.size(); ++i) {
    cout << nums[i] << endl;
  }
  return 0;
}

